VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsFindFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const MAX_PATH As Integer = 260
Private Const MAXDWORD As Integer = &HFFFF

Private Type FileTime
    dwLowDateTime   As Long
    dwHighDateTime  As Long
End Type

Private Type WIN32_FIND_DATA
    dwFileAttributes    As Long
    ftCreationTime      As FileTime
    ftLastAccessTime    As FileTime
    ftLastWriteTime     As FileTime
    nFileSizeHigh       As Long
    nFileSizeLow        As Long
    dwReserved0         As Long
    dwReserved1         As Long
    cFileName           As String * MAX_PATH
    cAlternateFileName  As String * 14
End Type

Private Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" _
                                (ByVal lpFileName As String, _
                                 lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" _
                                (ByVal hFindFile As Long, _
                                 lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindClose Lib "kernel32" _
                                (ByVal hFindFile As Long) As Long

Private Const FILE_ATTRIBUTE_READONLY   As Long = &H1
Private Const FILE_ATTRIBUTE_HIDDEN     As Long = &H2
Private Const FILE_ATTRIBUTE_SYSTEM     As Long = &H4
Private Const FILE_ATTRIBUTE_DIRECTORY  As Long = &H10
Private Const FILE_ATTRIBUTE_ARCHIVE    As Long = &H20
Private Const FILE_ATTRIBUTE_NORMAL     As Long = &H80
Private Const FILE_ATTRIBUTE_TEMPORARY  As Long = &H100
Private Const FILE_ATTRIBUTE_COMPRESSED As Long = &H800
Private Const INVALID_HANDLE_VALUE      As Long = 0

Dim mParentDirPath As String 'fBNg
Dim FindedDirs() As String 'fBNg
Dim FindCount As Long

Public Event Find()

Public Property Let ParentDirPath(tParentDirPath As String)
    mParentDirPath = AddDirSep(tParentDirPath)
End Property

Public Property Get FindDir(Index As Long) As String
    On Error Resume Next
    FindDir = FindedDirs(Index)
End Property

Public Property Get ListCount() As Long
    On Error Resume Next
    ListCount = UBound(FindedDirs) + 1
End Property

Public Sub SearchDirs(DirPath As String)
    Dim wfd As WIN32_FIND_DATA
    Dim FindFileHandle As Long
    Dim ret As Long
    Dim FindDirName As String
    Dim SerchDir As String
    Dim LookFlg As Long
    
    SerchDir = AddDirSep(DirPath)
    
    wfd.dwFileAttributes = FILE_ATTRIBUTE_READONLY Or _
                               FILE_ATTRIBUTE_HIDDEN Or _
                               FILE_ATTRIBUTE_SYSTEM Or _
                               FILE_ATTRIBUTE_DIRECTORY Or _
                               FILE_ATTRIBUTE_ARCHIVE Or _
                               FILE_ATTRIBUTE_NORMAL
                               
    FindFileHandle = FindFirstFile(SerchDir & "*", wfd)
    
    If FindFileHandle > 0 Then
        Do
            FindDirName = DelNull(wfd.cFileName)
            If FindDirName <> "." And FindDirName <> ".." Then
                If wfd.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY Then
                    FindCount = FindCount + 1
                    ReDim Preserve FindedDirs(FindCount)
                    FindedDirs(FindCount) = SerchDir & FindDirName
                    RaiseEvent Find
                    SearchDirs (FindedDirs(FindCount))
                    
                End If
            End If
            ret = FindNextFile(FindFileHandle, wfd)
        Loop While ret <> 0
    End If
    Call FindClose(FindFileHandle)
    
End Sub

Private Function AddDirSep(strPathName As String) As String
    If Right$(RTrim$(strPathName), 1) <> "\" Then
        AddDirSep = RTrim$(strPathName) & "\"
    Else
        AddDirSep = RTrim$(strPathName)
    End If
End Function

Private Function DelNull(Strings As String) As String
    Dim Pos As Long
    
    Pos = InStr(Strings, vbNullChar)
    If Pos Then
        DelNull = Left$(Strings, Pos - 1)
    Else
        DelNull = Strings
    End If
End Function

Private Sub Class_Initialize()
    FindCount = -1
End Sub
