VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DriveListBoxEX"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit


Private Const MAX_PATH = 260
Private Const MAX_PATH_PLUS1 = MAX_PATH + 1

Private Type tagPICTDESC
    cbSizeofStruct  As Long
    picType         As Long
    hImage          As Long
    xExt            As Long
    yExt            As Long
End Type
 
Private Type tagGUID
    Data1           As Long
    Data2           As Integer
    Data3           As Integer
    Data4(0 To 7)   As Byte
End Type

Private Declare Function OleCreatePictureIndirect Lib "olepro32.dll" _
                                (lpPictDesc As tagPICTDESC, _
                                 riid As tagGUID, _
                                 ByVal fPictureOwnsHandle As Long, _
                                 ipic As IPicture) As Long

Private Declare Function GetLogicalDriveStrings Lib "kernel32" Alias "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

Private Type tagSHFILEINFO
    hIcon           As Long                 '  out: icon
    iIcon           As Long                 '  out: icon index
    dwAttributes    As Long                 '  out: SFGAO_ flags
    szDisplayName   As String * MAX_PATH    '  out: display name (or path)
    szTypeName      As String * 80          '  out: type name
End Type
' t@C̏oB
Private Declare Function SHGetFileInfo Lib "shell32" Alias "SHGetFileInfoA" _
                                (ByVal pszPath As String, _
                                 ByVal dwFileAttributes As Long, _
                                 psfi As tagSHFILEINFO, _
                                 ByVal cbFileInfo As Long, _
                                 ByVal uFlags As Long) As Long

Private Const SHGFI_SMALLICON   As Long = &H1
Private Const SHGFI_DISPLAYNAME As Long = &H200
Private Const SHGFI_ICON        As Long = &H100
Private Const SHGFI_TYPENAME    As Long = &H400
Private Const SHGFI_OPENICON    As Long = &H2

Public Event Change()

Dim WithEvents mDriveListBox As ImageCombo
Attribute mDriveListBox.VB_VarHelpID = -1
Dim mIconList As ImageList
Dim mDrive As String

Public Sub FirstSet(tImageCombo As ImageCombo, tIconList As ImageList, SetDrive As String)
    Set mDriveListBox = tImageCombo
    Set mIconList = tIconList
    mIconList.ListImages.Clear
    mDrive = Left$(SetDrive, 2)
    Call Refresh
End Sub

Public Sub Refresh()
    Dim i%
    mDriveListBox.ComboItems.Clear
    Call GetDrives
    
    i% = 1
    Do While mDriveListBox.ComboItems(i%).Text <> StrConv(mDrive, vbUpperCase)
        i% = i% + 1
    Loop
    mDriveListBox.SelectedItem = mDriveListBox.ComboItems(i%)
End Sub

Private Sub GetDrives()
    Dim Buff As String * 105
    Dim DriveLetter As String
    Dim Temp As String

    Call GetLogicalDriveStrings(105, Buff)

    Temp = InStr(Buff, vbNullChar)
    Do
        DriveLetter = StrConv(Left$(Buff, Temp - 1), vbUpperCase)
        If Len(DriveLetter) = 0 Then Exit Do
        Buff = Right$(Buff, Len(Buff) - Temp)
        Call mDriveListBox.ComboItems.Add(, , Left$(DriveLetter, 2), GetIconKey(DriveLetter), , 0)
        Temp = InStr(Buff, vbNullChar)
    Loop While Temp
End Sub

Private Function GetIconKey(DriveLetter As String) As String
    Dim sfi             As tagSHFILEINFO
    Dim lngResult       As Long
    Dim strIconName     As String
    Dim intLoopCount    As Integer
    Dim blnFlag         As Boolean

    ' hCu啶ɕϊB
    DriveLetter = StrConv(DriveLetter, vbUpperCase)

    ' t@C̏oB
    lngResult = SHGetFileInfo(DriveLetter, _
                              0, _
                              sfi, _
                              Len(sfi), _
                              SHGFI_SMALLICON Or SHGFI_ICON Or SHGFI_DISPLAYNAME)
    strIconName = "ICON:" & sfi.iIcon
    blnFlag = True
    For intLoopCount = 1 To mIconList.ListImages.Count
        ' ɓo^ĂACȅꍇ
        If mIconList.ListImages.Item(intLoopCount).Key = strIconName Then
            blnFlag = False
            Exit For
        End If
    Next intLoopCount
    If blnFlag Then
        'ImageList֊i[
        Call mIconList.ListImages.Add(, _
                                          strIconName, _
                                          ConvertIcon(sfi.hIcon))
    End If
    GetIconKey = strIconName
End Function
Private Function ConvertIcon(hIcon As Long) As Picture
    If hIcon = 0 Then Exit Function
    
    Dim NewPic As Picture
    Dim udtPICTDESC As tagPICTDESC
    Dim udtGUID As tagGUID
    
    udtPICTDESC.cbSizeofStruct = Len(udtPICTDESC)
    udtPICTDESC.picType = vbPicTypeIcon
    udtPICTDESC.hImage = hIcon
    
    udtGUID.Data1 = &H20400
    udtGUID.Data4(0) = &HC0
    udtGUID.Data4(7) = &H46
   
    Call OleCreatePictureIndirect(udtPICTDESC, udtGUID, True, NewPic)
    
    Set ConvertIcon = NewPic
End Function
Public Property Get Drive() As String
    Drive = mDrive
End Property
Public Property Let Drive(DriveLetter As String)
    Dim i%
    
    If mDrive <> Left$(DriveLetter, 2) Then
        mDrive = Left$(DriveLetter, 2)
        For i% = 1 To mDriveListBox.ComboItems.Count - 1
            If mDriveListBox.ComboItems(i%).Text = StrConv(mDrive, vbUpperCase) Then
                Exit For
            End If
        Next
        mDriveListBox.SelectedItem = mDriveListBox.ComboItems(i%)
        RaiseEvent Change
    End If
        
End Property

Public Property Get Top() As Single
    Top = mDriveListBox.Top
End Property
Public Property Let Top(tTop As Single)
    mDriveListBox.Top = tTop
End Property

Public Property Get Left() As Single
    Left = mDriveListBox.Left
End Property
Public Property Let Left(tLeft As Single)
    mDriveListBox.Left = tLeft
End Property

Public Property Get Height() As Single
    Height = mDriveListBox.Height
End Property
Public Property Let Height(tHeight As Single)
    mDriveListBox.Height = tHeight
End Property

Public Property Get Width() As Single
    Width = mDriveListBox.Width
End Property
Public Property Let Width(tWidth As Single)
    mDriveListBox.Width = tWidth
End Property

Private Sub mDriveListBox_Click()
    Me.Drive = mDriveListBox.SelectedItem.Text
End Sub
